'General Declarations
Global Const TRUE = -1
Global Const FALSE = 0
Global Const MODAL = 1
Global Const MODELESS = 0
Global Const CHECKED = 1
Global Const UNCHECKED = 0
Global Const GRAYED = 2

' Declare for testing only
Global FilePath$

'MsgBox() constants
Global Const BoxOK = 0                      ' OK button only
Global Const BoxOKCANCEL = 1                ' OK and Cancel buttons
Global Const BoxABORTRETRYIGNORE = 2        ' Abort, Retry, and Ignore buttons
Global Const BoxYESNOCANCEL = 3             ' Yes, No, and Cancel buttons
Global Const BoxYESNO = 4                   ' Yes and No buttons
Global Const BoxRETRYCANCEL = 5             ' Retry and Cancel buttons
Global Const GioHeader = "VBCT Lurker"
Global Const GioDEFAULT = "Bad News"

'MsgBox Types (flags)
Global Const BoxSTOP = 16                   ' Critical message
Global Const BoxQUESTION = 32               ' Warning query
Global Const BoxEXCLAMATION = 48            ' Warning message
Global Const BoxINFORMATION = 64            ' Information message

' Constants for FileOpener
Global Const REPLACEFILE = 1
Global Const READFILE = 2
Global Const ADDTOFILE = 3
Global Const RANDOMFILE = 4
Global Const BINARYFILE = 5

' FileError constants
Global Const ErrBADFILENAMEORNUMBER = 52    ' A selection of likely runtime
Global Const ErrBADFILEMODE = 54            ' errors....
Global Const ErrFILEALREADYOPEN = 55
Global Const ErrDEVICEIO = 57
Global Const ErrDISKFULL = 61
Global Const ErrINPUTPASTENDOFFILE = 62
Global Const ErrBADFILENAME = 64
Global Const ErrDEVICEUNAVAILABLE = 68
Global Const ErrDISKNOTREADY = 71
Global Const ErrPATHDOESNOTEXIST = 76

' Global variables used by configuration routines
Global GSioLurkerPath As String

' LURKER.INI App names
Global Const GioAPPNAME = "Lurker"          ' for Get/Write Profile
Global Const GioLURKER = "Lurker.ini"       ' for Get/Write PrivateProfile
Global Const GioFILES = "Files"             ' for File information

' global constants for WIN.INI
Global Const GioLURKERPATH = "FilePath"     ' Path to Lurker files
Global Const GioNULLSTRING = ""             ' for zeroing Profiles

'Constants for modified msgbox routines FioMsgBox() and SioMsgBox
Global Const MB_OK = &H0
Global Const MB_ICONHAND = &H10
Global Const MB_ICONQUESTION = &H20
Global Const MB_ICONEXCLAMATION = &H30
Global Const MB_ICONASTERISK = &H40

'Global variables initialized at startup
Global GSioLurkerIni As String   ' Full path to Lurker.ini
Global GSioUserIni As String     ' Full path to active UserX.Ini
Global GSioActiveUser As String  ' Need to keep track of current user
Global GSioActiveHost As String  ' Name of active host

Type User
    Name As String
    ID As String
    Password As String
    Ini As String
End Type

'ListBox Messages for searching and clearing listboxes
Global Const WM_USER = 1024
Global Const LB_SETCURSEL = WM_USER + 7
Global Const LB_SELECTSTRING = WM_USER + 13
Global Const LB_SETTOPINDEX = WM_USER + 24
Global Const LB_RESETCONTENT = (WM_USER + 5)
Global Const CB_RESETCONTENT = WM_USER + 11

'Profile keys
Global Const GioPASSWORD = "Password"       ' Encrypted password
Global Const GioNOPASSWORD = "ZippoZeroNada"' Message if no password in LURKER.INI
Global Const GioDLDir = "DL Directory"      ' Where COMM stores DL'd files for processing

Type AllForumsNdx
     Name As String * 30        ' Name of Forums
     BytePos As Long            ' Byte position in Sectns.lst file
End Type

' These are used by to get date and time stamp from files
Global Const OF_EXIST = &H4000
Type OFSTRUCT
    RecLen As String * 1
    IsFixed As String * 1
    ErrCode As Integer
    r1 As Integer
    r2 As Integer
    CompleteName As String * 128
End Type
Declare Function OpenFile Lib "kernel" (ByVal fname$, aStruct As OFSTRUCT, ByVal ofstyle%) As Integer

Type forum
    Name As String
'    HMN As String
    GoWord As String
    Gateway As String
    MessageFile As String
'    ActiveSections As String
    MsgDirectory As String
    DLDirectory As String
    AppendMsg As Integer
    UserName As String
End Type

Type Section
    Number As Integer
    Name As String
End Type

